import{s as mt,f as it,n as pt,o as ct}from"../chunks/scheduler.37c15a92.js";import{S as ht,i as ft,g as l,s,r as st,A as dt,h as a,f as n,c as o,j as ot,u as lt,x as r,k as L,y as vt,a as i,v as at,d as rt,t as ut,w as gt}from"../chunks/index.7cb9c9b8.js";import{H as yt,E as wt}from"../chunks/EditOnGithub.858acfec.js";function _t(B){let u,U,M,$,g,C,m,J,P,p,K=`One of the challenges in Reinforcement Learning is <strong>creating environments</strong>. Fortunately for us, we can use game engines to do so.
These engines, such as <a href="https://unity.com/" rel="nofollow">Unity</a>, <a href="https://godotengine.org/" rel="nofollow">Godot</a> or <a href="https://www.unrealengine.com/" rel="nofollow">Unreal Engine</a>, are programs made to create video games. They are perfectly suited
for creating environments: they provide physics systems, 2D/3D rendering, and more.`,A,c,N='One of them, <a href="https://unity.com/" rel="nofollow">Unity</a>, created the <a href="https://github.com/Unity-Technologies/ml-agents" rel="nofollow">Unity ML-Agents Toolkit</a>, a plugin based on the game engine Unity that allows us <strong>to use the Unity Game Engine as an environment builder to train agents</strong>. In the first bonus unit, this is what we used to train Huggy to catch a stick!',E,h,Q='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/example-envs.png" alt="MLAgents environments"/> <figcaption>Source: <a href="https://github.com/Unity-Technologies/ml-agents">ML-Agents documentation</a></figcaption>',k,f,V="Unity ML-Agents Toolkit provides many exceptional pre-made environments, from playing football (soccer), learning to walk, and jumping over big walls.",I,d,W="In this Unit, we’ll learn to use ML-Agents, but <strong>don’t worry if you don’t know how to use the Unity Game Engine</strong>: you don’t need to use it to train your agents.",G,v,X="So, today, we’re going to train two agents:",S,y,Y="<li>The first one will learn to <strong>shoot snowballs onto a spawning target</strong>.</li> <li>The second needs to <strong>press a button to spawn a pyramid, then navigate to the pyramid, knock it over, and move to the gold brick at the top</strong>. To do that, it will need to explore its environment, which will be done using a technique called curiosity.</li>",z,w,Z,j,_,tt="Then, after training, <strong>you’ll push the trained agents to the Hugging Face Hub</strong>, and you’ll be able to <strong>visualize them playing directly on your browser without having to use the Unity Editor</strong>.",q,x,et="Doing this Unit will <strong>prepare you for the next challenge: AI vs. AI where you will train agents in multi-agents environments and compete against your classmates’ agents</strong>.",D,b,nt="Sound exciting? Let’s get started!",F,T,O,H,R;return g=new yt({props:{title:"An Introduction to Unity ML-Agents",local:"introduction-to-ml-agents",headingTag:"h1"}}),T=new wt({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit5/introduction.mdx"}}),{c(){u=l("meta"),U=s(),M=l("p"),$=s(),st(g.$$.fragment),C=s(),m=l("img"),P=s(),p=l("p"),p.innerHTML=K,A=s(),c=l("p"),c.innerHTML=N,E=s(),h=l("figure"),h.innerHTML=Q,k=s(),f=l("p"),f.textContent=V,I=s(),d=l("p"),d.innerHTML=W,G=s(),v=l("p"),v.textContent=X,S=s(),y=l("ul"),y.innerHTML=Y,z=s(),w=l("img"),j=s(),_=l("p"),_.innerHTML=tt,q=s(),x=l("p"),x.innerHTML=et,D=s(),b=l("p"),b.textContent=nt,F=s(),st(T.$$.fragment),O=s(),H=l("p"),this.h()},l(t){const e=dt("svelte-u9bgzb",document.head);u=a(e,"META",{name:!0,content:!0}),e.forEach(n),U=o(t),M=a(t,"P",{}),ot(M).forEach(n),$=o(t),lt(g.$$.fragment,t),C=o(t),m=a(t,"IMG",{src:!0,alt:!0}),P=o(t),p=a(t,"P",{"data-svelte-h":!0}),r(p)!=="svelte-1vcgfrn"&&(p.innerHTML=K),A=o(t),c=a(t,"P",{"data-svelte-h":!0}),r(c)!=="svelte-eyae6a"&&(c.innerHTML=N),E=o(t),h=a(t,"FIGURE",{"data-svelte-h":!0}),r(h)!=="svelte-14xtn5a"&&(h.innerHTML=Q),k=o(t),f=a(t,"P",{"data-svelte-h":!0}),r(f)!=="svelte-1d33h02"&&(f.textContent=V),I=o(t),d=a(t,"P",{"data-svelte-h":!0}),r(d)!=="svelte-w4zwn2"&&(d.innerHTML=W),G=o(t),v=a(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-2xi7mi"&&(v.textContent=X),S=o(t),y=a(t,"UL",{"data-svelte-h":!0}),r(y)!=="svelte-15sbbs0"&&(y.innerHTML=Y),z=o(t),w=a(t,"IMG",{src:!0,alt:!0}),j=o(t),_=a(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-14hc6j"&&(_.innerHTML=tt),q=o(t),x=a(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-11di5c1"&&(x.innerHTML=et),D=o(t),b=a(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-1lrk2z4"&&(b.textContent=nt),F=o(t),lt(T.$$.fragment,t),O=o(t),H=a(t,"P",{}),ot(H).forEach(n),this.h()},h(){L(u,"name","hf:doc:metadata"),L(u,"content",xt),it(m.src,J="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/thumbnail.png")||L(m,"src",J),L(m,"alt","thumbnail"),it(w.src,Z="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/envs.png")||L(w,"src",Z),L(w,"alt","Environments")},m(t,e){vt(document.head,u),i(t,U,e),i(t,M,e),i(t,$,e),at(g,t,e),i(t,C,e),i(t,m,e),i(t,P,e),i(t,p,e),i(t,A,e),i(t,c,e),i(t,E,e),i(t,h,e),i(t,k,e),i(t,f,e),i(t,I,e),i(t,d,e),i(t,G,e),i(t,v,e),i(t,S,e),i(t,y,e),i(t,z,e),i(t,w,e),i(t,j,e),i(t,_,e),i(t,q,e),i(t,x,e),i(t,D,e),i(t,b,e),i(t,F,e),at(T,t,e),i(t,O,e),i(t,H,e),R=!0},p:pt,i(t){R||(rt(g.$$.fragment,t),rt(T.$$.fragment,t),R=!0)},o(t){ut(g.$$.fragment,t),ut(T.$$.fragment,t),R=!1},d(t){t&&(n(U),n(M),n($),n(C),n(m),n(P),n(p),n(A),n(c),n(E),n(h),n(k),n(f),n(I),n(d),n(G),n(v),n(S),n(y),n(z),n(w),n(j),n(_),n(q),n(x),n(D),n(b),n(F),n(O),n(H)),n(u),gt(g,t),gt(T,t)}}}const xt='{"title":"An Introduction to Unity ML-Agents","local":"introduction-to-ml-agents","sections":[],"depth":1}';function bt(B){return ct(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ht extends ht{constructor(u){super(),ft(this,u,bt,_t,mt,{})}}export{Ht as component};
